//Fortran: EQUIVALENCE ( , V(1) )
Unit ASP1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASP1C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var T :Array of Complex;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);

implementation

procedure ASP1C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var T :Array of Complex;
                var S :Array of Integer; N :Integer; M :Integer;
                P :Integer);
var
I,J,K,L :Integer;
E,F,R,G,H :Real;
C,D :Complex;
V :Array [0..1] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27;
begin
if ( P = 1 )
 then goto _1;
goto _19;
_1:
for K:=1 to N do
 begin
  if ( K <> M )
   then goto _2;
  T[K-1] := A[(K-1)+(K-1)*N];
  A[(K-1)+(K-1)*N] := Cmplx(0.0,0.0);
  S[K-1] := K;
  goto _19;
_2:
  L := K;
  E := 0.0;
  for I:=K to N do
   begin
    F := 0.0;
    for J:=K to M do
     begin
      C := A[(I-1)+(J-1)*N];
      V[0] := Creal(C); //  
      V[1] := Aimag(C); //  
      R := Abs(V[0]);
      G := Abs(V[1]);
      H := EMax1(R,G);
      if ( H = 0.0 )
       then goto _3;
      R := R/H;
      G := G/H;
      R := R*R+G*G;
      H := H*Sqrt(R);
_3:
      if ( F < H )
       then F := H;
_4:
     end;
    H := 1.0/F;
    R := 0.0;
    for J:=K to M do
     begin
      C := A[(I-1)+(J-1)*N];
      V[0] := Creal(C); //  
      V[1] := Aimag(C); //  
      G := V[0]*H;
      R := R+G*G;
      G := V[1]*H;
      R := R+G*G;
_5:
     end;
    F := F*Sqrt(R);
    if ( E >= F )
     then goto _6;
    E := F;
    L := I;
_6:
   end;
  if ( L = K )
   then goto _8;
  for J:=1 to M do
   begin
    C := A[(L-1)+(J-1)*N];
    A[(L-1)+(J-1)*N] := A[(K-1)+(J-1)*N];
    A[(K-1)+(J-1)*N] := C;
_7:
   end;
_8:
  S[K-1] := L;
  F := 1.0/E;
  for J:=K to M do
   begin
_9:
    T[J-1] := MulC(A[(K-1)+(J-1)*N],Cmplx(F,0.0));
   end;
  C := T[K-1];
  V[0] := Creal(C); //  
  V[1] := Aimag(C); //  
  R := Abs(V[0]);
  G := Abs(V[1]);
  H := EMax1(R,G);
  if ( H <> 0.0 )
   then goto _10;
  T[K-1] := Cmplx(1.0,0.0);
  D := Cmplx(-E,0.0);
  goto _12;
_10:
  R := R/H;
  G := G/H;
  R := R*R+G*G;
  H := H*Sqrt(R);
  D := DivC(T[K-1],Cmplx(H,0.0));
  T[K-1] := AddC(T[K-1],D);
  H := 1.0/Sqrt(1.0+H);
  for J:=K to M do
   begin
_11:
    T[J-1] := MulC(T[J-1],Cmplx(H,0.0));
   end;
  D := MulC(Cmplx(-E,0.0),D);
_12:
  for J:=K to M do
   begin
_13:
    A[(K-1)+(J-1)*N] := T[J-1];
   end;
  if ( K = N )
   then goto _17;
  L := K+1;
  for I:=L to N do
   begin
    C := Cmplx(0.0,0.0);
    for J:=K to M do
     begin
_14:
      C := AddC(C,MulC(A[(I-1)+(J-1)*N],Conjg(T[J-1])));
     end;
    for J:=K to M do
     begin
_15:
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(C,T[J-1]));
     end;
_16:
   end;
_17:
  T[K-1] := D;
_18:
 end;
_19:
for I:=1 to N do
 begin
  K := S[I-1];
  C := B[I-1];
  B[I-1] := B[K-1];
  B[K-1] := C;
_20:
 end;
X[0] := DivC(B[0],T[0]);
if ( N = 1 )
 then goto _23;
for I:=2 to N do
 begin
  L := I-1;
  C := Cmplx(0.0,0.0);
  for J:=1 to L do
   begin
_21:
    C := AddC(C,MulC(A[(I-1)+(J-1)*N],X[J-1]));
   end;
  X[I-1] := DivC((SubC(B[I-1],C)),T[I-1]);
_22:
 end;
_23:
for I:=N to M do
 begin
  if ( I = N )
   then goto _24;
  X[I-1] := Cmplx(0.0,0.0);
_24:
 end;
I := N;
_25:
C := Cmplx(0.0,0.0);
for J:=I to M do
 begin
_26:
  C := AddC(C,MulC(X[J-1],A[(I-1)+(J-1)*N]));
 end;
for J:=I to M do
 begin
_27:
  X[J-1] := SubC(X[J-1],MulC(C,Conjg(A[(I-1)+(J-1)*N])));
 end;
I := I-1;
if ( I >= 1 )
 then goto _25;
end;

end.
